diff --git a/src/backend/catalog/pg_subscription.c b/src/backend/catalog/pg_subscription.c
index c32fc8137d..4039768865 100644
--- a/src/backend/catalog/pg_subscription.c
+++ b/src/backend/catalog/pg_subscription.c
@@ -353,6 +353,7 @@ GetSubscriptionRelState(Oid subid, Oid relid, XLogRecPtr *sublsn)
 
 	if (!HeapTupleIsValid(tup))
 	{
+		table_close(rel, AccessShareLock);
 		*sublsn = InvalidXLogRecPtr;
 		return SUBREL_STATE_UNKNOWN;
 	}
